************************************************************
* eHealth Business Connector Generic RELEASE NOTES         *
************************************************************

this release contains all business connectors , with an empty configuration file. 
they can be used to create a connector for a new target group

4.9.5 release (may 2026)
   . adding             vsbnetasync business connector:
                            - DF105 V3 replaces previous version of DF105 (use same existing method VsbNetMohmService.reportDelivery)
                            - new operation DF019 getNotifyRectifications (new method VsbNetInvoiceService.getNotifyRectifications)
                        see examples in:
                            - examples\be\ehealth\businessconnector\vsbnet\async\session\VsbNetPostGenericAsyncIntegrationTest
                            - examples\be\ehealth\businessconnector\vsbnet\async\session\VsbNetGetGenericAsyncIntegrationTest
   . adding             business connector MyCareNet ChapterIV:
                            - new service ChapterIVAgreementConsultationPharmacyService
                        see examples in:
                            - examples\be\ehealth\businessconnector\chapterIV\integration\ChapterIVAgreementConsultationPharmacyServiceIntegrationTest
   . adding             support for SAML2
   . adding             support for ECC Timestamping certificate validation
   . adding             support for short-lived signatures
   . adding             support for BOSA remote signing
   . improvement        minor technical connector refactorings

4.9.4 (april 2026)
   . internal release

4.9.3 (april 2026)
   . internal release

4.9.2 (april 2026)
   . internal release

4.9.1 (april 2026)
   . internal release

4.9.0 (april 2026)
   . internal release

4.8.6 (february 2026)
   . adding             .NET Framework 4.7.2 build

4.8.5 (february 2026)
   . bug-fix            remove following methods causing errors for .NET users:
                                  - JaxbContextFactory.getJaxbContextForPackage(Package p)
                                  - JaxbContextFactory.initJaxbContext(Package p)
                        adapt DaasAttributeService by using the JaxbContextFactory.getJaxbContextForClass method, in order to avoid the following error: "Unable to create jaxbContext for package be.fgov.ehealth.daas.complextype.v1"
   . bug-fix            .NET BeID module: avoid NullPointerException in BeIDDistributedSigner while iterating over BeIDDigests

4.8.4 release (october 2025)
   . improvement     two distinct versions of .NET packaging with IKVM 8.11.2: .NET Framework 4.8 and .NET 6.0
   . adding          asynchronous business service eAgreement v2
                        See examples in examples\be\ehealth\businessconnector\mycarenet\agreementasyncv2\session
   . deleting        business service MyCareNet Insurability V2

4.8.3 release (october 2025)
   . internal release

4.8.2 release (october 2025)
   . internal release

4.8.1 release (september 2025)
   . internal release

4.8.0-beta-1 release (june 2025)
   . change          .Net connector build with IKVM 8.11.2 and .NET 6.0

4.7.3 release (april 2025)
   . adding          synchronous business service eAgreement v2
                        See examples in examples\be\ehealth\businessconnector\mycarenet\agreementv2\session
   . bug-fix         TherLink eID proof: fix determination of cms signature algorithm

4.7.2 release (april 2025)
   . internal release

4.7.1 release (april 2025)
   . internal release

4.7.0 release (april 2025)
   . internal release

4.6.0 release (september 2024)
   . adding:                synchronous business services MemberData IrisCareNet and WalCareNet to the MemberData V2 module : see usage examples in
                                    - examples\be\ehealth\businessconnector\test\mycarenet\memberdatav2\session\regional
   . adding:                asynchronous business services MemberData IrisCareNet and WalCareNet to the MemberData async module : see usage examples in
                                    - examples\be\ehealth\businessconnector\test\mycarenet\memberdataasync\regional
   . adding:                business service eAttest v3: validated for the logopedist target group : see usage examples in
                                     - examples\be\ehealth\businessconnector\test\mycarenet\attestv3\LogopedistIntegrationTest
   . adding:                business service invoicing async: validated for the logopedist target group : see usage examples in
                                     - examples\be\ehealth\businessconnector\test\invoicing
   . changes already in 4.6.0-beta-1:
            - business service intrahub v1: update to hubservices xsd v1.3.0 that uses latest kmerh version 1.40.2
            - business service intrahub v3: update to hubservices xsd v3.6.0 that uses latest kmerh version 1.40.2


4.6.0-beta-1 release (june 2024)
   . change:
            - business service intrahub v1: update to hubservices xsd v1.3.0 that uses latest kmerh version 1.40.2
            - business service intrahub v3: update to hubservices xsd v3.6.0 that uses latest kmerh version 1.40.2

4.5.4 release (april 2024)
  . bug-fix         business connector eh2ebox and ehboxv3:
                        remove the text/plain or text/html restriction on the mime type of the message body, in order to be able to use other mime types for eH2eBox.  . improvement     update dependency minor versions, including org.apache.commons:commons-compress to v1.26.1 that fixes some security vulnerabilities: https://commons.apache.org/proper/commons-compress/security.html
  . bug-fix         business connector MyCareNet Registration:
                        remove timezone from generated xml (some oa's do not accept it).
  . improvement     update dependency minor versions, including org.apache.commons:commons-compress to v1.26.1 that fixes some security vulnerabilities: https://commons.apache.org/proper/commons-compress/security.html

4.5.3 release (april 2024)
   . internal release

4.5.2 release (april 2024)
   . internal release

4.5.1 release (april 2024)
   . internal release

4.5.0 release (april 2024)
   . internal release


4.4.0 release (september 2023)
 . improvement      business connector MyCareNet ChapterIV: timestamp validation is now compatible with Timestamping V2. The timestamp is first validated against Timestamping V1. In case of failure,
                    the timestamp is then validated against Timestamping V2. That has an impact on the connector api:
                    
                    - The following method:
                    
                        public org.bouncycastle.tsp.TimeStampResponse getTimeStampResponse()
                    
                    - has been replaced with the following one:
                    
                         public org.bouncycastle.tsp.TimeStampToken getTimeStampToken()
                         
 . improvement      business connector intrahub V3: Two config properties have been added in order to be able to make calls with a CBE author:
 
                         - hubv3.session.is-cbe : false by default. Must be set to true if the session has a STS token containing a CBE number.
                            
                         - hubv3.request.create-author : true by default. Setting this property to false will let you set yourself a 
                                                         be.fgov.ehealth.standards.kmehr.schema.v1.AuthorType to the be.fgov.ehealth.hubservices.core.v1.RequestType.
                                                         Use this option if the connector does not manage to generate the author correctly for a target group not supported
                                                         by the connector (e.g: an organization).
                                                         
                     business connector intrahub:   similarly, properties hub.session.is-cbe and hub.request.create-author may be used.

4.3.0 release (april 2023)  
   . improvement        Straight runtime compatibility up to JDK 15:
                            . Here are the Maven dependencies that have been added to the connector
                              for this purpose (in case of Java 8 they replace those provided by the JDK): 
                                             
                                    <dependency>
                                      <groupId>jakarta.xml.ws</groupId>
                                      <artifactId>jakarta.xml.ws-api</artifactId>
                                      <version>2.3.3</version>
                                    </dependency>
                                    <dependency>
                                      <groupId>com.sun.xml.ws</groupId>
                                      <artifactId>jaxws-rt</artifactId>
                                      <version>2.3.6</version>
                                      <scope>runtime</scope>
                                    </dependency>
                                    <dependency>
                                      <groupId>com.sun.xml.messaging.saaj</groupId>
                                      <artifactId>saaj-impl</artifactId>
                                      <version>1.3.28</version>
                                    </dependency>
                                    <dependency>
                                      <groupId>jakarta.xml.bind</groupId>
                                      <artifactId>jakarta.xml.bind-api</artifactId>
                                      <version>2.3.3</version>
                                    </dependency>
                                    <dependency>
                                      <groupId>com.sun.xml.bind</groupId>
                                      <artifactId>jaxb-impl</artifactId>
                                      <version>2.3.8</version>
                                    </dependency>
                                    
                            . For JDK 16 and up, the following VM options must be added, in order to access internal JDK classes:
   
                               --add-exports java.xml/com.sun.org.apache.xerces.internal.dom=ALL-UNNAMED
                               --add-exports java.xml/com.sun.org.apache.xerces.internal.util=ALL-UNNAMED
                               --add-exports java.xml/com.sun.org.apache.xerces.internal.jaxp=ALL-UNNAMED 
                               
    . improvement        default connector service calls to signature algorithm RSA-SHA-256
    . improvement        default STS to WS-Trust interface, in order to use by default the new version of SecurityTokenService,
                         which includes the latest hashing (SHA-256) and signing algorithms (RSA-SHA-256 / ECDSA-SHA-256).    
                         This change should be reflected in terms of sts endpoint config:
                         
                               endpoint.sts=$uddi{uddi:ehealth-fgov-be:business:iamsecuritytokenservice:v1}  
                                                              
   . change             Align SOAP actions to the Civics v2 WSDL. No Impact on client code.
   . deleting           business service Dics V3
   . deleting           business service MyCareNet Insurability V1
   . deleting           business service MyCareNet eAttest V1
   
4.3.0-beta-3 release (december 2022)
    . bugfix          business service eAttest v3: the MessageVersion attribute specified in CancelAttestationRequestInput or SendAttestationRequestInput was not set by the connector in the Detail element,
                      leading to a service response containing the INVALID_MESSAGE_NAME error.
                      
    . bug-fix         Removal of the Sender element from common input (the presence of the Sender element, even if empty, may lead to the FORBIDDEN_COMMON_INPUT_ORIGIN_INPUT_SENDER MyCareNet error).               
        
                  
4.3.0-beta-2 release (december 2022)
   . internal release
   

4.2.0 release (october 2022)
  . improvement     business connector ehboxv3: align with WS Publication cookbook:
                       - For clarity, in the connector api DocumentMessage.document is renamed DocumentMessage.body.
                       - The connector now translates this body in the WS interface as EncryptableTextContent in the Document xml element (was translated as EncryptableBinaryContent).
                       - The MineType of the body must be text/plain or text/html.
                       - See the latest eHealtBox v.3 Publication WS cookbook for the full body specifications.

  . removing        business connector consultrn V1.


4.1.2 release (may 2022)
     . improvement      
            minor updates of following xsd's:
                - eMOHM_DF103_ConsultApplication_V4.xsd
                    <xs:documentation>=========== XSD Version 4.1.0 =========</xs:documentation>
                    <xs:documentation>10/10/2021: eMOHM_Common.xsd is van versie 7.0.0 naar 7.1.0 gegaan</xs:documentation>
                - eMOHM_DF104_ConsultSupportAndRepair_V4.xsd
                    <xs:documentation>=========== XSD Version 4.1.0 =========</xs:documentation>
                    <xs:documentation>10/10/2021: eMOHM_Common.xsd is van versie 7.0.0 naar 7.1.0 gegaan</xs:documentation>
                - eMOHM_DF107_PushApplicationView_V4.xsd
                        <xs:documentation>=========== XSD Version 4.1.0 =========</xs:documentation>
                    <xs:documentation>10/10/2021: eMOHM_Common.xsd is van versie 7.0.0 naar 7.1.0 gegaan</xs:documentation>
                - eMOHM_DF112_ConsultSupportAndRepairList_V2.xsd
                    <xs:documentation>=========== XSD Version 2.1.0 =========</xs:documentation>
                    <xs:documentation>10/10/2021: eMOHM_Common.xsd is van versie 7.0.0 naar 7.1.0 gegaan</xs:documentation>
                - eMOHM_Common_V7.xsd
                    <xs:documentation>=========== XSD Version 7.1.0 =========</xs:documentation>
                    <xs:documentation>10/10/2021: Statussen voor advies ZKC toegevoegd aan ApplicationStatusType</xs:documentation>	
                - WZCMH_Common_V3.xsd
                    <xs:documentation>30/09/2020: CertificateType: verwijderen van velden Coma, MS, ALS, Huntington</xs:documentation>
                - VSB_Common_V2.xsd
                    <xs:documentation>=========== XSD Version 2.3.0 =========</xs:documentation>
                    <xs:documentation>22/10/2020: Added context REVA_Z in ContextType</xs:documentation>
                    <xs:documentation>=========== XSD Version 2.2.0 =========</xs:documentation>
                    <xs:documentation>24/09/2020: Added BELRAI_VL in CareEntityCodeType</xs:documentation>
                    <xs:documentation>24/06/2020: Added context MDO in ContextType</xs:documentation>
    
    . removing           
            synchronous business service therlink: remove proof type SISREADING 
            => method createProofForSisReading() removed from be.ehealth.businessconnector.therlink.builder.ProofBuilder interface.

    . improvement           
            synchronous business service dicsV5: update to latest xsd-dics (5.1.4)

4.1.1 release (may 2022)
   . internal release

4.1.0 release (may 2022)
   . internal release

4.0.2 release (october 2021)
   . adding
            - synchronous business service eAttest v3
              See examples in examples\be\ehealth\businessconnector\test\mycarenet\attestv3\session
              
   . improvement
            - eAgreement: add businessResponse field to get the business content of the response in a straightforward manner (see also release.notes.business-mycareneteagreement.txt).
            - use technical connector V4 (see release.notes.technical-core.txt, release.notes.technical-bootsrap.txt, release.notes.technical-jca.txt, release.notes.technical-ra.txt and release.notes.technical-signature.txt)
           
   . bugfix
            - ConsultRN v2 phonetic search: update xsd model to make possible a phonetic search without given names.
              See examples in examples\be\ehealth\businessconnector\test\consultrn\consultrnv2\session\ConsultrnSessionPersonServiceIntegrationTest
     
  
4.0.1 release (october 2021)
  . internal partner release (not published on ehealth portal only distributed to Recipe, Reseau Santé Wallon and Vitalink)
                
3.21.2 release (may 2021)
    . adding:      
            - new MOHM operations for the vsbnetasync business service:
                           createApplicationV3
                           getCreateApplicationV3
                           consultHistory
                           getConsultHistory
                           consultApplicationV4
                           getConsultApplicationV4
                           consultSupportAndRepairV4
                           getConsultSupportAndRepairV4
                           getPushDecisionV4
                           getPushApplicationViewV4
                           consultSupportAndRepairListV2
                           getConsultSupportAndRepairListV2
                           
3.21.1 release (may 2021)
   . internal release
   
3.21.0 release (may 2021)
   . internal release
3.20.2 release (october 2020)
   . adding
            - synchronous business service eAgreement
              See examples in examples\be\ehealth\businessconnector\mycarenet\agreement\session
            - asynchronous business service eAgreement
              See examples in examples\be\ehealth\businessconnector\mycarenet\agreementasync\session
              
   .improvement
            - Person Service: update to xsd version 1.0.5
            - CBSS Person Service: update to xsd version 1.0.3

 
3.20.1 release (september 2020)
   . internal release
   
3.20.0 release (september 2020)
   . internal release
   
3.19.1 release (april 2020)
   . adding:
            - synchronous business service DICS v5
            - synchronous business service ConsultRN v2 Person Service
            - synchronous business service ConsultRN v2 CBSS Person Service

   . improvement
            - new method for the business service mycarenetmedadmin (medadmin async service): get REJECT messages
            - new method for the business service WS Consent: getPatientConsentStatus
            - new method for the business service DICSv4: findNonMedicinalProduct
            - new target groups for the business service MemberData Sync/Async: clinical psychologists + clinical orthopedagogist

3.19.0 release (april 2020)
   . internal release

3.18.0 release (october 2019)
   . improvement
            Service validated for following AR78 professionals:
                clinicalorthopedagogist, clinicalpsychologist and oraldentalhygienist

   . adding:
            - synchronous business service Mediprima v2
              /!\ For the orgpharmacy target group the following additional saml attribute designator is required for Mediprima Consultation V2 (see configuration file):
                   urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:ehealth:1.0:pharmacy:nihii-number:recognisedpharmacy:nihii11

            - synchronous business service MemberData v2
            - asynchronous business service MemberData Async

   . adding:             
            - Service validated for the following AR78 professionals:
                               clinicalorthopedagogist, clinicalpsychologist and oraldentalhygienist.
              Here is the session management saml configuration for each of these professions: 

                # clinicalorthopedagogist  
                sessionmanager.samlattribute.1=urn:be:fgov:identification-namespace,urn:be:fgov:ehealth:1.0:certificateholder:person:ssin,${sender.inss}
                sessionmanager.samlattribute.2=urn:be:fgov:identification-namespace,urn:be:fgov:person:ssin,${sender.inss}
                sessionmanager.samlattributedesignator.1=urn:be:fgov:identification-namespace,urn:be:fgov:ehealth:1.0:certificateholder:person:ssin
                sessionmanager.samlattributedesignator.2=urn:be:fgov:identification-namespace,urn:be:fgov:person:ssin
                sessionmanager.samlattributedesignator.3=urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:person:ssin:ehealth:1.0:fpsph:clinicalorthopedicpedagogue:boolean
                sessionmanager.samlattributedesignator.4=urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:person:ssin:ehealth:1.0:nihii:clinicalorthopedicpedagogue:nihii11
                sessionmanager.samlattributedesignator.5=urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:person:ssin:ehealth:1.0:professional:clinicalorthopedicpedagogue:boolean
                
                # clinicalpsychologist
                sessionmanager.samlattribute.1=urn:be:fgov:identification-namespace,urn:be:fgov:ehealth:1.0:certificateholder:person:ssin,${sender.inss}
                sessionmanager.samlattribute.2=urn:be:fgov:identification-namespace,urn:be:fgov:person:ssin,${sender.inss}
                sessionmanager.samlattributedesignator.1=urn:be:fgov:identification-namespace,urn:be:fgov:ehealth:1.0:certificateholder:person:ssin
                sessionmanager.samlattributedesignator.2=urn:be:fgov:identification-namespace,urn:be:fgov:person:ssin
                sessionmanager.samlattributedesignator.3=urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:person:ssin:ehealth:1.0:fpsph:clinicalpsychologist:boolean
                sessionmanager.samlattributedesignator.4=urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:person:ssin:ehealth:1.0:nihii:clinicalpsychologist:nihii11
                sessionmanager.samlattributedesignator.5=urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:person:ssin:ehealth:1.0:professional:clinicalpsychologist:boolean
                
                # oraldentalhygienist
                sessionmanager.samlattribute.1=urn:be:fgov:identification-namespace,urn:be:fgov:ehealth:1.0:certificateholder:person:ssin,${sender.inss}
                sessionmanager.samlattribute.2=urn:be:fgov:identification-namespace,urn:be:fgov:person:ssin,${sender.inss}
                sessionmanager.samlattributedesignator.1=urn:be:fgov:identification-namespace,urn:be:fgov:ehealth:1.0:certificateholder:person:ssin
                sessionmanager.samlattributedesignator.2=urn:be:fgov:identification-namespace,urn:be:fgov:person:ssin
                sessionmanager.samlattributedesignator.3=urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:person:ssin:ehealth:1.0:fpsph:dentalhygienist:boolean
                sessionmanager.samlattributedesignator.4=urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:person:ssin:ehealth:1.0:nihii:dentalhygienist:nihii11
                sessionmanager.samlattributedesignator.5=urn:be:fgov:certified-namespace:ehealth,urn:be:fgov:person:ssin:ehealth:1.0:professional:dentalhygienist:boolean


3.17.1 release (april 2019)
   . adding:
            - synchronous business service MemberData 
            - synchronous business service eAttest v2 
   . change:
            - business service intrahub v1: Support fort the ID-ENCRYPTION-KEY kmehr identifier. This identifier is meant to be added to the hcparty identifiers of the request for operations where the response must be encrypted.
              The ID-ENCRYPTION-KEY value contains the base64 encoded ETK of the sender.
              By default ID-ENCRYPTION-KEY is not added since service providers might not be compliant yet.
              To activate ID-ENCRYPTION-KEY the config property see migration.guide.generic.txt.
   
3.17.0 release (april 2019)
 . internal release 

3.16.1 release (october 2018)
   . adding:
            - new therlink operation HasTherapeuticLink 
   . change:
            - business service intrahub v3: Pagination added to getTransactionList 
            - business service intrahub v3: Support fort the ID-ENCRYPTION-KEY kmehr identifier. This identifier is meant to be added to the hcparty identifiers of the request for operations where the response must be encrypted.
              The ID-ENCRYPTION-KEY value contains the base64 encoded ETK of the sender.
              By default ID-ENCRYPTION-KEY is not added since service providers might not be compliant yet (the kmehr.hubservicev3.identifier.id.idencryptionkey property is false).
              To activate ID-ENCRYPTION-KEY the config property kmehr.hubservicev3.identifier.id.idencryptionkey must be set to true.
   . bugfix:
            - business service registration: remove mandatory checks on fields InputReference, NIPReference, OutputReference of mycarenet CommonOutput. These fields
              are optional in the mycarenet response.   
              
3.16.0 release (september 2018)
 . internal release                        

3.16.0-beta-3 release (june 2018)
   . adding:
            - new asynchronous business service mycarenetmedadmin (medadmin async service)
   . adding:
            - new asynchronous business service vsbnetasync (includes mohm, invoice and insurability async services).
              See examples in examples\be\ehealth\businessconnector\vsbnet\async
            - new synchronous business service vsbnetinsurability (includes insurability service)
              See examples in examples\be\ehealth\businessconnector\vsbnetinsurability
   . Your specific vsbnet licensing properties to be set in the config:
            vsbnet.licence.username=
            vsbnet.licence.password=
   . Normally the vsbnet etk properties are already correct in the config file:
            vsbnet.mohm.keydepot.identifiertype=CBE
            vsbnet.mohm.keydepot.identifiervalue=881629733
            vsbnet.mohm.keydepot.application=WZCMH
            vsbnet.invoice.keydepot.identifiertype=CBE
            vsbnet.invoice.keydepot.identifiervalue=881629733
            vsbnet.invoice.keydepot.application=WZCMH

3.16.0-beta-2 release (june 2018)
 . internal release  
             
3.16.0-beta-1 release (june 2018)
 . internal release  

3.16.0-beta-0 release (june 2018)
 . internal release              

3.15.1 release (april 2018)
   . adding:
            - new business service dicsv4
            - new business service consultrn (includes identifyPerson, phoneticSearch and managePerson.registerPerson)
            - new business service mediprimauma
            - new business service eh2ebox (included in the ehboxv3 module) 
            - new generic async business service genins (geninsasync module)

3.15.0 release (april 2018)
 . internal release
 
3.14.2 release (february 2017)
    . see    release.notes.business-intrahubv3.txt

3.14.2-beta-1 release (november 2017)

3.14.2-beta-0 internal release (november 2017)

3.14.1 release (octobre 2017)

3.14.0 release (octobre 2017)

3.14.0-beta-0 release (september 2017)
   . adding    new business service intrahub v3
   . adding    new business service mediprima

3.13.1 release (juli 2017)
   . adding    new business service MyCarenet eAttest

3.13.0 internal release (july 2017)

3.12.1 release (june 2017)  
   . adding    new business service Civics V2
   . adding    new business service Dics V3
   . deleting  business service Civics V1
   . deleting  business service Dics V2

3.12.0 internal release (mai 2017)

3.11.1 release
  .  bugfix for dll incompatability in utilities-addressbook

3.11.0 internal release (october 2016)
  .  using latest version of technical connector 3.11.0
  .  adding    new business service genericinsurability v2, dics, dicsv2

3.10.4 release (september 2016)
  . using latest version of technical connector 3.10.4
  . using latest version of business connector 3.10.4
  
3.10.3 release
   . internal release

3.10.2 release (july 2016)
  . using latest version of technical connector 3.10.2
  . using latest version of business connector 3.10.2 
  
3.10.1 release
   . internal release

3.10.0 release (june 2016)
   . improvement      uniformisation of all connector versions
   
3.4.11 (may 2016)
  . internal partner release (not published on ehealth portal only distributed to Recipe, Reseau Santé Wallon and Vitalink)
  . adding    new business service addressbook
  . adding    bootstrap configurations for all business modules
  . change    config properties splitted between sender and careprovider properties ( makes mandate configurations easier)
  . upgrade   technical connector version 3.4.11
  . upgrade   business connector 3.4.11 
  
1.0.0-beta-2 release
  . using latest version of technical connector 3.4.0-beta-9 
  . using latest version of business connector 3.4.0-beta-9 
